##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (samplename)	= PkgName
# sampledir (sampledir)		= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config/include file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for MailXch

%define name	ksm-mailxch
%define version	1.0.1
%define release	4.1.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _uxbindir	/usr/bin
%define _uxsbindir	/usr/sbin
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs for exchanging eMails
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Networking/Email/Utilities
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	% {_tmppath}/% {name}-% {version}-% {release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	fetchmail,postfix
Requires:	ksm-lib-sh >= 5.0.1-0.0.0,ksm-ring >= 1.0.0-1.0.0
#Provides:	sampled
Conflicts:	ksm-mail+news
#Obsoletes:	mysampled

%description
This package contains following programs for exchanging eMails:
 chkovsizmail, mailboxq, mailring, mailxch, mailxch-now, mlocks, 
 togglemailxch, togglemring.

Please check/configure:
 /usr/local/etc/mail.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) % {_confdir}/sample.conf
#%config % {_confdir}/sample.conf
#%config % {_scnfdir}/sample
#%attr(644,root,root)% {_scnfdir}/sample
%attr(600,root,root)%{_confdir}/mail.conf

#%attr(744,root,root)% {_rcdir}/sampled

#%attr(777,root,root)% {_bindir}/rcsampled
%attr(754,root,root)%{_bindir}/chkovsizmail
%attr(755,root,root)%{_bindir}/mailboxq
%attr(754,root,root)%{_bindir}/mailring
%attr(754,root,root)%{_bindir}/mailxch
%attr(754,root,root)%{_bindir}/mailxch-now
%attr(754,root,root)%{_bindir}/mlocks
%attr(754,root,root)%{_bindir}/togglemailxch
%attr(754,root,root)%{_bindir}/togglemring

%{_datadir}/RELEASE
%{_datadir}/VERSION

#/usr/share/applications/sample.desktop
#% {_icondir}/16x16/apps/sample.png
#% {_icondir}/22x22/apps/sample.png
#% {_icondir}/32x32/apps/sample.png
#% {_icondir}/48x48/apps/sample.png
#% {_icondir}/64x64/apps/sample.png
#% {_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/mailboxq.1.gz

%docdir %{_man8dir}
%{_man8dir}/chkovsizmail.8.gz
%{_man8dir}/mailring.8.gz
%{_man8dir}/mailxch.8.gz
%{_man8dir}/mailxch-now.8.gz
%{_man8dir}/mlocks.8.gz
%{_man8dir}/togglemailxch.8.gz
%{_man8dir}/togglemring.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#% {_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# disable sample and stop sampled
test -x %{_bindir}/togglemailxch && %{_bindir}/togglemailxch -d > /dev/null 2>&1
test -x %{_bindir}/togglemring && %{_bindir}/togglemring -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1

# backup config files
test -e %{_confdir}/mail.conf && cp %{_confdir}/mail.conf %{_confdir}/mail.conf.rpmsave
#test -e %{_scnfdir}/sample && cp %{_scnfdir}/sample %{_scnfdir}/sample.rpmsave

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname. config file needs a version at first cnfvar!
cf=%{_confdir}/mail.conf
cnfvars=$(grep -v '^#' $cf | grep '[[:alnum:]]' | grep -v '\[' | cut -sd '=' -f1)
cnfvars=$(echo $cnfvars | cut -d ' ' -f2-)
ret=0

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/mail.directory \
#	/usr/share/applications/mail.desktop \
#	/usr/share/applications/mail-admin.desktop

if [ "$1" == 1 ]; then					# install package
	# set links
#	ln -sf %{_rcdir}/maild rcmaild
#	ln -sf /usr/bin/prog %{_bindir}/mymail

	echo "Configure $cf"
#	echo "Users must create HOME/.mailrc with update-mail"
else							# upgrade package
	# update global conf
	c='' s='' t=''
	ret=0
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi

#		# update array vars MainArr
#		cnt=0 i=0
#		cnt=${#MainArr[@]}			# max index of array
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				# array MainArr
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi

		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.mailrc with update-mail"
fi
chmod 600 $cf
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# disable sample and stop sampled
test -x %{_bindir}/togglemailxch && %{_bindir}/togglemailxch -d -q > /dev/null 2>&1
test -x %{_bindir}/togglemring && %{_bindir}/togglemring -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampled && %{_rcdir}/sampled stop > /dev/null 2>&1

#if [ "$1" == 0 ]; then					# remove package
#	# backup config files
	test -e %{_confdir}/mail.conf && cp %{_confdir}/mail.conf %{_confdir}/mail.conf.rpmsave
#	test -e %{_scnfdir}/sample && cp %{_scnfdir}/sample %{_scnfdir}/sample.rpmsave
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/maildir

	# rm links
	#test -e %{_bindir}rcmaild && rm -f %{_bindir}rcmaild
	#test -e %{_bindir}/mymail && rm -f %{_bindir}/mymail

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/mail.directory \
	#	/usr/share/applications/mail.desktop \
	#	/usr/share/applications/mail-admin.desktop
else							# upgrade package
	# enable mail and start maild
	%{_bindir}/togglemailxch -e > /dev/null 2>&1
	#%{_rcdir}/maild start > /dev/null 2>&1
fi
exit 0

%changelog
* Sun Apr 07 2024 Repomaster <repomaster@kaesmann-online.de> 1.0.1-4.1.0
- 'mailxch'has been revised/improved.

* Wed Jan 24 2024 Repomaster <repomaster@kaesmann-online.de> 1.0.1-4.0.0
- Deleted 'mailexch'.
- Added 'mailxch-now'
- 'mailring' has been revised/improved.

* Sun Jan 14 2024 Repomaster <repomaster@kaesmann-online.de> 1.0.1-3.1.0
- 'chkovsizmail' has been revised/improved:
  Output of Errmsgs reworked.

* Sun Jan 14 2024 Repomaster <repomaster@kaesmann-online.de> 1.0.1-3.0.0
- Following progs have been revised/improved:
  mailexch, mailxch

* Mon Mar 14 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-2.1.0
- Following progs have been revised/improved:
  mailexch, mailxch

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-2.0.0
- Update to the libfuncstd-sh 4.0.0

* Sat Feb 04 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.0.0
- All scripts have been revised/improved
  (using function GetOpt).

* Sun Dec 18 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.8.0
- All scripts have been revised.

* Wed Oct 15 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.7.1
- The docu of the package has been revised.

* Wed Apr 03 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.1-0.7.0
- The script togglemail has been renamed to togglemailxch.
- The scripts togglemailxch and togglemring have been revised.

* Sat Oct 06 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.6.0
- Error in chkovsizmail corrected.

* Wed Sep 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.5.0
- The package has been revised.

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.4.0
- The config file mail.conf and
  the RPM scriptlets has been revised.

* Thu Apr 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.3.0
- The config update process has been revised.

* Fri Apr 20 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.2.0
- The RPM scriptlets are revised.

* Tue Apr 03 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0
- The release naming scheme has changed ('.ksm' is removed).

* Mon Jan 03 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Wed Mar 24 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0.ksm
- The install dependencies are corrected.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.4.ksm
- Read version and dependency infos from external files.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.3.ksm
- The docu has changed.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.2.ksm
- The package name (Release) has changed.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.ksm.0.1
- The RPM scriptlets are corrected.

* Sat Nov 14 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.ksm.0.0
- The program ma is renamed to mailexch.

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The package management has changed to RPM.
